using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;
using Telerik.WinControls.Docking;
using Telerik.WinControls;

namespace RadDockingMenu
{
    public partial class Form1 : RadForm
    {
        DockMenuItem doSomethingItem1;
        DockMenuItem doSomethingItem2;

        public Form1()
        {
            InitializeComponent();

            dockPanel1.DockContextMenu.DropDownOpening += new CancelEventHandler(DockContextMenu_DropDownOpening);
            dockPanel2.DockContextMenu.DropDownOpening += new CancelEventHandler(DockContextMenu_DropDownOpening);
        }

        void DockContextMenu_DropDownOpening(object sender, CancelEventArgs e)
        {
            DockContextMenu dockMenu = sender as DockContextMenu;
            // if the context menu invoker is dockPanel1
            if (dockMenu.DockWindow == dockPanel1)
            {
                // get the "Hide" item and hide it
                dockMenu.GetDefaultItem("Hide").Visibility = ElementVisibility.Collapsed;

                if (doSomethingItem1 == null)
                {
                    doSomethingItem1 = new DockMenuItem(DockState.Floating, "Custom Item for DockPanel1");

                    doSomethingItem1.Click += new EventHandler(doSomethingItem1_Click);
                    dockMenu.Items.Add(doSomethingItem1);
                }
            }
            // if the context menu invoker is dockPanel2
            else if (dockMenu.DockWindow == dockPanel2)
            {
                // get the "Floating" item and hide it
                dockMenu.GetDefaultItem("Floating").Visibility = ElementVisibility.Collapsed;

                if (doSomethingItem2 == null)
                {
                    doSomethingItem2 = new DockMenuItem(DockState.AutoHide, "Custom Item for DockPanel2");

                    doSomethingItem2.Click += new EventHandler(doSomethingItem2_Click);
                    dockMenu.Items.Add(doSomethingItem2);
                }

                // if the context menu invoker is a tabbed document
                if (dockMenu.DockWindow.DockState == DockState.TabbedDocument)
                {
                    doSomethingItem2.Visibility = ElementVisibility.Collapsed;
                }
                else
                {
                    doSomethingItem2.Visibility = ElementVisibility.Visible;
                }
            }
        }

        void doSomethingItem2_Click(object sender, EventArgs e)
        {
            dockPanel2.DockState = ((DockMenuItem)sender).DockState;
            // Do something here
        }

        void doSomethingItem1_Click(object sender, EventArgs e)
        {
            dockPanel1.DockState = ((DockMenuItem)sender).DockState;
            // Do something here
        }
    }
}